/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.datastore.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for CommitResponse.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommitResponse extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ResponseHeader header;

  /**
   * The result of performing the mutation (if any).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private MutationResult mutationResult;

  /**

   * The value returned may be {@code null}.
   */
  public ResponseHeader getHeader() {
    return header;
  }

  /**

   * The value set may be {@code null}.
   */
  public CommitResponse setHeader(ResponseHeader header) {
    this.header = header;
    return this;
  }

  /**
   * The result of performing the mutation (if any).
   * The value returned may be {@code null}.
   */
  public MutationResult getMutationResult() {
    return mutationResult;
  }

  /**
   * The result of performing the mutation (if any).
   * The value set may be {@code null}.
   */
  public CommitResponse setMutationResult(MutationResult mutationResult) {
    this.mutationResult = mutationResult;
    return this;
  }

}
