/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.datastore.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Entity.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Entity extends GenericJson {

  /**
   * The entity's key.
   *
   * An entity must have a key, unless otherwise documented (for example, an entity in
   * Value.entityValue may have no key). An entity's kind is its key's path's last element's kind,
   * or null if it has no key.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Key key;

  /**
   * The entity's properties.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, Property> properties;

  static {
    // hack to force ProGuard to consider Property used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Property.class);
  }

  /**
   * The entity's key.
   *
   * An entity must have a key, unless otherwise documented (for example, an entity in
   * Value.entityValue may have no key). An entity's kind is its key's path's last element's kind,
   * or null if it has no key.
   * The value returned may be {@code null}.
   */
  public Key getKey() {
    return key;
  }

  /**
   * The entity's key.
   *
   * An entity must have a key, unless otherwise documented (for example, an entity in
   * Value.entityValue may have no key). An entity's kind is its key's path's last element's kind,
   * or null if it has no key.
   * The value set may be {@code null}.
   */
  public Entity setKey(Key key) {
    this.key = key;
    return this;
  }

  /**
   * The entity's properties.
   * The value returned may be {@code null}.
   */
  public java.util.Map<String, Property> getProperties() {
    return properties;
  }

  /**
   * The entity's properties.
   * The value set may be {@code null}.
   */
  public Entity setProperties(java.util.Map<String, Property> properties) {
    this.properties = properties;
    return this;
  }

}
